/*
	File:		SpinCursor.h
	
	Contains:	Cursor code.

	Written by:	John Wang (And Think Reference people)

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<1>		11/15/94	JW		New.

	To Do:
	
*/

#ifdef THINK_C
#define		applec
#endif

#define countingHand	1000	//	id of the 'acur' resource 
#define watchCursor		1002
#define beachBall		1003
#define movieStrip 		1004

#define rate			12		//	Make the animation faster by decreasing the rate and slower
								//	by increasing the rate

#define HiWrd(aLong)	(((aLong) >> 16) & 0xFFFF)

typedef struct {
	short		numberOfFrames;	//	number of cursors to animate
	short		whichFrame;		//	current frame number
	CursHandle	frame[];		//	Pointer to the first cursor
} acur, *acurPtr, **acurHandle;

/* ------------------------------------------------------------------------- */

Boolean		InitAnimatedCursors(short acurID, short interval);
void		ReleaseAnimatedCursors(void);
void		SpinCursor(void );
